# Generated by go2rpm 1
%bcond_without check

# https://github.com/open-policy-agent/opa
%global goipath         github.com/open-policy-agent/opa
Version:                0.27.1
# short_commit is used to display in opa version
%global short_commit    e514c035

%gometa

%global common_description %{expand:
An open source, general-purpose policy engine.

The Open Policy Agent (OPA) is an open source, general-purpose policy engine
that enables unified, context-aware policy enforcement across the entire
stack.}

%global golicenses      LICENSE
%global godocs          docs/content CHANGELOG.md README.md MAINTAINERS.md\\\
                        ADOPTERS.md CODE_OF_CONDUCT.md CONTRIBUTING.md\\\
                        GOVERNANCE.md SECURITY.md

Name:           open-policy-agent
Release:        2%{?dist}
Summary:        Open source, general-purpose policy engine

# Upstream license specification: Apache-2.0
License:        ASL 2.0
URL:            %{gourl}
Source0:        %{gosource}
# Make telemetry opt-out
Patch0:         0001-Make-telemetry-opt-out.patch
# Skip tests requiring network
Patch1:         0001-Skip-tests-requiring-network.patch
# Fix test failing on 32-bit arch (cf. https://github.com/open-policy-agent/opa/pull/3265)
Patch2:         https://github.com/open-policy-agent/opa/pull/3265.patch#/0001-tests-fix-test-failing-on-32-bit-arch.patch

BuildRequires:  golang(github.com/fsnotify/fsnotify)
BuildRequires:  golang(github.com/ghodss/yaml)
BuildRequires:  golang(github.com/gobwas/glob)
BuildRequires:  golang(github.com/gorilla/mux)
BuildRequires:  golang(github.com/olekukonko/tablewriter)
BuildRequires:  golang(github.com/OneOfOne/xxhash)
BuildRequires:  golang(github.com/peterh/liner)
BuildRequires:  golang(github.com/pkg/errors)
BuildRequires:  golang(github.com/prometheus/client_golang/prometheus)
BuildRequires:  golang(github.com/prometheus/client_golang/prometheus/promhttp)
BuildRequires:  golang(github.com/rcrowley/go-metrics)
BuildRequires:  golang(github.com/sirupsen/logrus)
BuildRequires:  golang(github.com/spf13/cobra)
BuildRequires:  golang(github.com/spf13/pflag)
BuildRequires:  golang(github.com/xeipuuv/gojsonreference)
BuildRequires:  golang(github.com/yashtewari/glob-intersection)
BuildRequires:  golang(golang.org/x/net/http2)
BuildRequires:  golang(golang.org/x/net/http2/h2c)

%if %{with check}
# Tests
BuildRequires:  golang(github.com/sirupsen/logrus/hooks/test)
BuildRequires:  golang(github.com/stretchr/testify/assert)
BuildRequires:  golang(github.com/stretchr/testify/require)
%endif

%description
%{common_description}

%gopkg

%prep
%goprep
%autopatch -p1
# Remove code related to wasm, as we have to disable wasm,
# wasmtime not being packaged in Fedora yet
rm resolver/wasm/wasm.go version/wasm.go
rm internal/rego/opa/opa.go internal/wasm/sdk/opa/capabilities/capabilities.go
rm -rf internal/wasm/sdk/internal/wasm internal/wasm/sdk/opa/opa.go

%build
%gobuild -o %{gobuilddir}/bin/generate-man %{goipath}/build/generate-man
export LDFLAGS="-X %{goipath}/version.Version=%{version} -X %{goipath}/version.Vcs=%{short_commit} -X %{goipath}/version.Timestamp=$(./build/get-build-timestamp.sh) "
%gobuild -o %{gobuilddir}/bin/opa %{goipath}
mkdir _man
%{gobuilddir}/bin/generate-man _man
rm %{gobuilddir}/bin/generate-man

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/
install -d -p -m 0755                   %{buildroot}%{_mandir}/man1
install -D -p -m 0644 _man/*            %{buildroot}%{_mandir}/man1/

%if %{with check}
%check
%gocheck
%endif

%files
%license LICENSE
%doc docs/content CHANGELOG.md README.md MAINTAINERS.md ADOPTERS.md CODE_OF_CONDUCT.md
%doc CONTRIBUTING.md GOVERNANCE.md SECURITY.md
%{_mandir}/man1/opa*.1*
%{_bindir}/*

%gopkgfiles

%changelog
* Sat Mar 13 2021 Olivier Lemasle <o.lemasle@gmail.com> - 0.27.1-2
- Fix failing test on 32-bit architectures

* Sat Mar 13 2021 Olivier Lemasle <o.lemasle@gmail.com> - 0.27.1-1
- Update to latest upstream 0.27.1 (fixes #1936740)

* Tue Jan 26 2021 Olivier Lemasle <o.lemasle@gmail.com> - 0.26.0-2
- Remove dependency on github.com/wasmerio/go-ext-wasm (Fixes #1919476)
- Use upstream fix for Go 1.16 compatibility

* Thu Jan 21 2021 Olivier Lemasle <o.lemasle@gmail.com> - 0.26.0-1
- Update to latest upstream 0.26 (note: wasm disabled)

* Tue Oct 27 2020 Olivier Lemasle <o.lemasle@gmail.com> - 0.24.0-2
- Fix failing tests on 32-bit architectures
- Make telemetry service opt-out
- Fix version output

* Tue Oct 27 2020 Olivier Lemasle <o.lemasle@gmail.com> - 0.24.0-1
- Update to latest upstream 0.24

* Tue Apr 07 08:15:00 CEST 2020 Olivier Lemasle <o.lemasle@gmail.com> - 0.18.0-1
- Initial package

